--------------------------------------------------------------------------------
-- Copyright(C) 2005 by Xilinx, Inc. All rights reserved.
-- This text/file contains proprietary, confidential
-- information of Xilinx, Inc., is distributed under license
-- from Xilinx, Inc., and may be used, copied and/or
-- disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc. Xilinx hereby grants you
-- a license to use this text/file solely for design, simulation,
-- implementation and creation of design files limited
-- to Xilinx devices or technologies. Use with non-Xilinx
-- devices or technologies is expressly prohibited and
-- immediately terminates your license unless covered by
-- a separate agreement.
--
-- Xilinx is providing this design, code, or information
-- "as is" solely for use in developing programs and
-- solutions for Xilinx devices. By providing this design,
-- code, or information as one possible implementation of
-- this feature, application or standard, Xilinx is making no
-- representation that this implementation is free from any
-- claims of infringement. You are responsible for
-- obtaining any rights you may require for your implementation.
-- Xilinx expressly disclaims any warranty whatsoever with
-- respect to the adequacy of the implementation, including
-- but not limited to any warranties or representations that this
-- implementation is free from claims of infringement, implied
-- warranties of merchantability or fitness for a particular
-- purpose.
--
-- Xilinx products are not intended for use in life support
-- appliances, devices, or systems. Use in such applications are
-- expressly prohibited.
--
-- This copyright and support notice must be retained as part
-- of this text at all times. (c) Copyright 2005 Xilinx, Inc.
-- All rights reserved.
--------------------------------------------------------------------------------
--
-- Filename - fvg_yuv.vhd
-- Author - P. Szanto
-- Creation - 27 June 2006
--
-- Description -
--
-- Bypass FVG module for YUV and YCbCr inputs
-- Simply outputs the CC0 channel (with width extension, if parameters are not set correctly)
--
-- $RCSfile: fvg_yuv.vhd,v $ $Revision: 1.4 $ $Date: 2006/06/30 19:01:23 $
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

use work.rank2d_utils.ALL;

entity fvg_yuv is
generic(
        DW_CC0     : integer := 8;
        DW_CC1     : integer := 8;
        DW_CC2     : integer := 8;
        DW         : integer := 10
      );
port   (
        clk        : in  std_logic;
        cc0_in     : in  std_logic_vector(DW_CC0-1 downto 0);
        cc1_in     : in  std_logic_vector(DW_CC1-1 downto 0);
        cc2_in     : in  std_logic_vector(DW_CC2-1 downto 0);
        filter_val : out std_logic_vector(DW-1 downto 0)
      );
end fvg_yuv;


architecture rtl of fvg_yuv is

constant CONST_0  : std_logic_vector(127 downto 0) := x"00000000000000000000000000000000";

begin


GEN_LARGE:
if (DW > DW_CC0) generate
   filter_val <= CONST_0(DW-DW_CC0-1 downto 0) & cc0_in;
end generate;
GEN_SMALL:
if (DW <= DW_CC0) generate
   filter_val <= cc0_in(DW-1 downto 0);
end generate;

--filter_val <= (CONST_0(DW-DW_CC0-1 downto 0) & cc0_in) when (DW > DW_CC0) else cc0_in(DW-1 downto 0);

end rtl;
