library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity sub_module is
generic(
         DW : integer := 10;
         NUM : integer := 0
);
port(
         clk    : in  std_logic;
         en     : in  std_logic;
         op_a   : in  std_logic_vector(DW downto 0);
         op_b   : in  std_logic_vector(DW downto 0);
         res    : out std_logic_vector(DW downto 0)
);
end sub_module;

architecture rtl of sub_module is

signal sub_res: std_logic_vector(DW downto 0);
attribute syn_dspstyle : string;
attribute syn_dspstyle of sub_res : signal is "logic";
attribute use_dsp48: string;
attribute use_dsp48 of sub_res: signal is "no";

constant CONST_0  : std_logic_vector(127 downto 0) := x"00000000000000000000000000000000";

signal comp_res : std_logic;

begin


process(clk)
begin
if (clk'event and clk='1') then
   if (en='1') then
      sub_res <= op_a - op_b;
   end if;
end if;
end process;

process(clk)
begin
if (clk'event and clk='1') then
   if (en='1') then
      if (op_a < op_b) then   
         comp_res <= '1';
      else
         comp_res <= '0';
      end if;
   end if;
end if;
end process;

--res <= sub_res;
res <= comp_res & CONST_0(DW-1 downto 0);

end rtl;
