function [data_out] = rank1D_golden(data_in, NTAPs, RANK)
% MATLAB model for the one dimensional rank-order filter

  if (RANK>NTAPs) error('Parameter RANK should be less or equal than NTAPs') 
  end;

  % Transform input data array to row vector if needed:
  len = product(size(data_in));
  data = reshape(data_in, 1, len);

  % Initial conditions:
  data_out = [];

  for i=1:len-NTAPs+1
    D = sort(data(i:i+NTAPs-1));
    data_out = [data_out, D(RANK+1)]; 
  end;
end

