function saltpepper_add(image_name)
% This function superimposes salt&pepper noise on an image
% The resulting file is saved with suffix _sp

in = imread(image_name);
[x,y,z]=size(in);
% Generate Salt & Pepper noise
rnd = rand(x, y);
Treshold = 0.03;
rnds = max(rnd, 1-Treshold);
rnds = min((rnds - 1 + Treshold)*10000,1);
rndp = max(rnd, Treshold);
rndp = min((rndp - Treshold)*10000,1);
fin = in;
for i=1:z 
  fin(:,:,i)=fin(:,:,i).*uint8(rndp)+uint8(rnds*255); 
end;
imagesc(fin); figure(gcf)
wh_dot = find(image_name=='.'); 
% if there are more than one '.'s, such as in '../../something.jpg', chose the last one
wh_dot = wh_dot(size(wh_dot,2)); 
ext = image_name(wh_dot+1:size(image_name,2));
imwrite(fin, [image_name(1:wh_dot-1),'_sp.',ext], ext);


