function output_image = padd2d( input_image, WH, WW, METHOD)
  % Padds centered input_image with WH rows on top and bottom, WW cols on left and right
  % METHOD == 0 => padds with zeros
  % METHOD != 0 => padds with mirrored pixels

  [size_y, size_x, planes] = size(input_image);
  output_image = zeros( size_y+2*WH, size_x+2*WW, planes ); 
  output_image( 1+WH:size_y+WH , 1+WW:size_x+WW, : ) = input_image;

  if (METHOD == 0) return; end
  if (WW>0)
    for i=1:planes
      output_image( 1+WH:size_y+WH , 1:WW, i ) = fliplr(input_image(1:size_y, 1:WW, i));
      output_image( 1+WH:size_y+WH , WW+size_x+1: size_x+2*WW, i ) = fliplr(input_image(1:size_y, size_x+1-WW:size_x, i));
    end
  end;

  if (WH>0)
    for i=1:planes
      output_image( 1:WH , 1:size_x+2*WW, i ) = flipud( output_image(WH+1:2*WH, 1:size_x+2*WW, i ));
      output_image( size_y+1+WH:size_y+2*WH , 1: size_x+2*WW, i) = flipud( output_image( size_y+1:size_y+WH, 1:size_x+2*WW, i));
    end
  end