function [input_image, input_image_r, input_image_g, input_image_b, size_x, size_y, hsync_in, hsync_pos, hsync_period, stop_time, reset, pix_en_in ] = rank2d_init_mdl(RANK, WV, WH, pix_en_period)

  %input_file = imread('../../test_images/sw_1.bmp');
  %input_file = imread('../../test_images/pattern_s.bmp');
  %input_file = imread('../../test_images/pattern_s2.bmp');
  %input_file = imread('../../test_images/pattern_s3_sp.bmp');
  %input_file = imread('../../test_images/white_24.bmp');
  %input_file = imread('../../test_images/testpic_1s.bmp');
  input_file = imread('../../test_images/pcb_sp.bmp');
  figure(1); imagesc(input_file);

  % Create padded image
  input_image = padd2d( input_file, ceil(WV/2), ceil(WH/2), 1);

  [size_y, size_x, planes] = size(input_image);
  figure(2); imagesc(uint8(input_image));
  input_image_r = reshape(input_image(:,:,1)', size_x*size_y, 1);
  input_image_g = reshape(input_image(:,:,2)', size_x*size_y, 1);
  input_image_b = reshape(input_image(:,:,3)', size_x*size_y, 1);

  PADDING = 10;
  FLUSH = RANK*RANK;
  % Adding 10 delay samples to synchronize with control signals
  input_image_r = vertcat(zeros(PADDING,1), input_image_r);
  input_image_g = vertcat(zeros(PADDING,1), input_image_g);
  input_image_b = vertcat(zeros(PADDING,1), input_image_b);
  
  % Reset generator:   Insert ones whenever reset needs to be asserted
  reset = zeros(size_x*size_y,1);
  reset(100)=1;
  wh = find(reset == 1);
  last_reset = wh(size(wh,1));

  input_image_r_reshape =input_image_r; 
  input_image_g_reshape =input_image_g; 
  input_image_b_reshape =input_image_b; 

  for i=1:size(wh,1)
    input_image_r_reshape = [input_image_r_reshape(1:wh(i)); input_image_r];
    input_image_g_reshape = [input_image_g_reshape(1:wh(i)); input_image_g];
    input_image_b_reshape = [input_image_b_reshape(1:wh(i)); input_image_b];
  end

  size_resample = size(input_image_r_reshape,1);
  
  % Resampling the input according to pix_en_period (replicating samples pix_en_preiod times)
  input_image_r =[];
  input_image_g =[];
  input_image_b =[];  
    for i=1:pix_en_period 
        input_image_r=horzcat(input_image_r, input_image_r_reshape); 
        input_image_g=horzcat(input_image_g, input_image_g_reshape); 
        input_image_b=horzcat(input_image_b, input_image_b_reshape); 
    end;
  input_image_r=reshape(input_image_r', size_resample*pix_en_period,1);
  input_image_g=reshape(input_image_g', size_resample*pix_en_period,1);
  input_image_b=reshape(input_image_b', size_resample*pix_en_period,1);
  clear input_image_r_reshape input_image_g_reshape input_image_b_reshape;

  stop_time = size_resample * pix_en_period+40; 
  active_size = size_resample-PADDING;

  pix_en_in = ones(size_x*size_y+FLUSH,1); 
  if (pix_en_period>1) 
    pix_en_in=horzcat(pix_en_in, zeros(size(pix_en_in),pix_en_period-1)); 
    pix_en_in=reshape(pix_en_in', size(pix_en_in,1)*pix_en_period ,1);
  end;
  pix_en_in = [zeros(PADDING*pix_en_period,1); pix_en_in ];
  pix_en_in_reshape = pix_en_in;
  for i=1:size(wh,1)
    pix_en_in_reshape = [pix_en_in_reshape(1:wh(i)*pix_en_period); pix_en_in];
  end
  pix_en_in = pix_en_in_reshape;

  hsync=zeros(size_x*pix_en_period,1);
  hsync((size_x-2)*pix_en_period+1:(size_x-1)*pix_en_period)=1;
  hsync_full=hsync;
  for i=1:size_y-1
      hsync_full=[hsync_full; hsync];
  end
  hsync_full=[zeros(PADDING*pix_en_period,1); hsync_full];
  hsync_full((PADDING-3)*pix_en_period+1:(PADDING-2)*pix_en_period)=1;
  hsync_reshape = hsync_full;
  for i=1:size(wh,1)
    hsync_reshape = [hsync_reshape(1:wh(i)*pix_en_period); hsync_full];
  end
  hsync_in = hsync_reshape;
  
  reset = zeros(stop_time,1); reset(wh*pix_en_period) = 1;
  
  hsync_pos = size_x-1;
  hsync_period = size_x;

end