%post processing

wh=find(reset == 1); last_reset = wh(size(wh,1)); 

%processing ModelSim output
mod = 2; %(WH+1)/2, missing outputs at startup

out_size=size(hw_out_r,1);
hw_out_r_t = hw_out_r(last_reset+5:out_size);
hw_out_g_t = hw_out_g(last_reset+5:out_size);
hw_out_b_t = hw_out_b(last_reset+5:out_size);
hw_out_pix_en_t = hw_out_pix_en(last_reset+5:out_size);

hw_image_r = uint8(zeros(size_y, size_x, 1));
hw_image_g = uint8(zeros(size_y, size_x, 1));
hw_image_b = uint8(zeros(size_y, size_x, 1));

row=1;
col=1;

for i=1:size(hw_out_r_t,1)
   if (hw_out_pix_en_t(i)==1)
       hw_image_r(row, col, 1) = uint8(hw_out_r_t(i));
       hw_image_g(row, col, 1) = uint8(hw_out_g_t(i));
       hw_image_b(row, col, 1) = uint8(hw_out_b_t(i));
       if (col==size_x)
           col=1;
           row=row+1;
       else
           col=col+1;
       end;
   end;
end

hw_image = hw_image_r;
hw_image(:, :, 2) = hw_image_g;
hw_image(:, :, 3) = hw_image_b;

out_image = hw_image(WV_real:size_y, WH:size_x,:);
golden_image = uint8(rank2d_golden( input_padded, WV_real, WH, RANK, Y_GENERATOR_TYPE));
diff_image=abs(double(out_image)-double(golden_image));
max_diff = max(max(max(diff_image)));
max_diff_non_zero = (max_diff>0);

figure(3); 
subplot(2+max_diff_non_zero,1,1); imagesc(out_image); title('Cropped output image');
subplot(2+max_diff_non_zero,1,2); imagesc(golden_image); title('Matlab reference model image');

if (max_diff_non_zero)
  subplot(3,1,3); imagesc(uint8(diff_image*(255/max_diff))); title('Amplified difference between output and reference images');
end;
