function rank2d_top_config(this_block)

  % Revision History:
  %
  %   04-Apr-2006  (18:56 hours):
  %     Original code was machine generated by Xilinx's System Generator after parsing
  %     E:\Projects\Xilinx\2d_rank\2drank_v6\2drank_top.vhd
  %
  %

  block_L0 = this_block.blockName;           % Black Box
  block_L1 = get_param(block_L0,'Parent');   % Subsystem
  
  DW_CC0   = evalin('base', get_param(block_L1, 'DATA_WIDTH_CH0'));
  DW_CC1   = evalin('base', get_param(block_L1, 'DATA_WIDTH_CH1'));
  DW_CC2   = evalin('base', get_param(block_L1, 'DATA_WIDTH_CH2'));
  DW       = evalin('base', get_param(block_L1, 'DATA_WIDTH_FILTER'));
  WW       = evalin('base', get_param(block_L1, 'WINDOW_WIDTH'));
  WH_real  = evalin('base', get_param(block_L1, 'WINDOW_HEIGHT'));
  NI       = evalin('base', get_param(block_L1, 'NEW_INPUTS'));
  LW_MAX   = evalin('base', get_param(block_L1, 'MAX_HORIZONTAL_RES'));
  FVG_TYPE = evalin('base', get_param(block_L1, 'Y_GENERATOR_TYPE'));
  FAMILY   = lower(this_block.getDeviceFamilyName());
  
  TAPr = WW * WH_real;
  WH = TAPr/WH_real;
  WH_virt = ceil(WH_real/NI)*NI;
  TAP = WH*WH_virt;
  TAPb = ceil(log2(TAP)); 

  this_block.setTopLevelLanguage('VHDL');
  this_block.setEntityName('rank2d_top');

  % System Generator has to assume that your entity  has a combinational feed through; 
  % if it  doesn't, then comment out the following line:
  % this_block.tagAsCombinational;

  this_block.addSimulinkInport('cc0_in');
  this_block.addSimulinkInport('cc1_in');
  this_block.addSimulinkInport('cc2_in');
  this_block.addSimulinkInport('rank');
  this_block.addSimulinkInport('pix_en_in');
  this_block.addSimulinkInport('vs_in');
  this_block.addSimulinkInport('hs_in');
  this_block.addSimulinkInport('rst');

  this_block.addSimulinkOutport('cc0_out');
  this_block.addSimulinkOutport('cc1_out');
  this_block.addSimulinkOutport('cc2_out');
  this_block.addSimulinkOutport('pix_en_out');
  this_block.addSimulinkOutport('vs_out');
  this_block.addSimulinkOutport('hs_out');
  
  vs_out_port = this_block.port('vs_out');
  vs_out_port.setType('UFix_1_0');
  vs_out_port.useHDLVector(false);
  hs_out_port = this_block.port('hs_out');
  hs_out_port.setType('UFix_1_0');
  hs_out_port.useHDLVector(false);
  pix_en_out_port = this_block.port('pix_en_out');
  pix_en_out_port.setType('UFix_1_0');
  pix_en_out_port.useHDLVector(false);

  this_block.port('cc0_in').width = DW_CC0;
  this_block.port('cc1_in').width = DW_CC1;
  this_block.port('cc2_in').width = DW_CC2;
  this_block.port('rank').width = TAPb;
  this_block.port('cc0_out').width = DW_CC0;
  this_block.port('cc1_out').width = DW_CC1;
  this_block.port('cc2_out').width = DW_CC2;

  % -----------------------------
  if (this_block.inputTypesKnown)
    % do input type checking, dynamic output type and generic setup in this code block.

    if (this_block.port('rst').width ~= 1);
      this_block.setError('Input data type for port "rst" must have width=1.');
    end

    this_block.port('rst').useHDLVector(false);

    if (this_block.port('pix_en_in').width ~= 1);
      this_block.setError('Input data type for port "pix_en_in" must have width=1.');
    end

    this_block.port('pix_en_in').useHDLVector(false);

    % (!) Port 'rgb_in' appeared to have dynamic type in the HDL -- please add type checking as appropriate;

    if (this_block.port('vs_in').width ~= 1);
      this_block.setError('Input data type for port "vs_in" must have width=1.');
    end

    this_block.port('vs_in').useHDLVector(false);

    if (this_block.port('hs_in').width ~= 1);
      this_block.setError('Input data type for port "hs_in" must have width=1.');
    end

    this_block.port('hs_in').useHDLVector(false);

  % (!) Port 'rgb_out' appeared to have dynamic type in the HDL
  % --- you must add an appropriate type setting for this port
  end  % if(inputTypesKnown)
  % -----------------------------

  % System Generator found no apparent clock signals in the HDL, assuming combinational logic.
  % -----------------------------
   if (this_block.inputRatesKnown)
     inputRates = this_block.inputRates; 
     uniqueInputRates = unique(inputRates); 
     outputRate = uniqueInputRates(1);
     for i = 2:length(uniqueInputRates)
       if (uniqueInputRates(i) ~= Inf)
         outputRate = gcd(outputRate,uniqueInputRates(i));
       end
     end  % for(i)
     for i = 1:this_block.numSimulinkOutports 
       this_block.outport(i).setRate(outputRate); 
     end  % for(i)
   end  % if(inputRatesKnown)
   ce_period = ceil(WH_real/NI);
   this_block.addClkCEPair('clk','ce', 1);
  % -----------------------------

  % (!) Custimize the following generic settings as appropriate. If any settings depend
  %      on input types, make the settings in the "inputTypesKnown" code block.
  this_block.addGeneric('DATA_WIDTH_CH0', DW_CC0);
  this_block.addGeneric('DATA_WIDTH_CH1', DW_CC1);
  this_block.addGeneric('DATA_WIDTH_CH2', DW_CC2);
  this_block.addGeneric('DATA_WIDTH_FILTER', DW);
  this_block.addGeneric('WINDOW_WIDTH', WW);
  this_block.addGeneric('WINDOW_HEIGHT', WH_real);
  this_block.addGeneric('NEW_INPUTS', NI);
  this_block.addGeneric('MAX_HORIZONTAL_RES', LW_MAX);
  this_block.addGeneric('Y_GENERATOR_TYPE', FVG_TYPE);
  this_block.addGeneric('FAMILY', ['"' FAMILY '"']);
  
  % Add addtional source files as needed.
  %  |-------------
  %  | Add files in the order in which they should be compiled.
  %  | If two files "a.vhd" and "b.vhd" contain the entities
  %  | entity_a and entity_b, and entity_a contains a
  %  | component of type entity_b, the correct sequence of
  %  | addFile() calls would be:
  %  |    this_block.addFile('b.vhd');
  %  |    this_block.addFile('a.vhd');
  %  |-------------

  %    this_block.addFile('');
  %    this_block.addFile('');
  this_block.addFile('../../../GenXlib_utils.vhd');  
  this_block.addFile('../../../GenXlib_arch.vhd');  
  this_block.addFile('../../../rank2d_utils.vhd');
  this_block.addFile('../../../rank2d_latency.vhd');  
  this_block.addFile('../../../lbuff_mem.vhd');
  this_block.addFile('../../../delay_line.vhd');
  this_block.addFile('../../../delay_line_srl16.vhd');
  this_block.addFile('../../../delay_line_srl32.vhd');
  this_block.addFile('../../../fvg_sum.vhd');
  this_block.addFile('../../../fvg_yuv.vhd');
  this_block.addFile('../../../fvg_y.vhd');      
  this_block.addFile('../../../comp_module.vhd');
  this_block.addFile('../../../sub_inst.vhd');
  this_block.addFile('../../../sub_inst_v2.vhd');
  this_block.addFile('../../../sub_inst_v4.vhd');
  this_block.addFile('../../../cntr1_new.vhd');
  this_block.addFile('../../../cntr1_old.vhd');  
  this_block.addFile('../../../filter_core.vhd');
  this_block.addFile('../../../rank2d_top.vhd');  
return;


